﻿using System;
using System.Diagnostics;
using System.Diagnostics.CodeAnalysis;
using System.Linq;
using Delay;

[assembly: SuppressMessage("Microsoft.Design", "CA2210:AssembliesShouldHaveValidStrongNames", Justification = "Simple example assembly.")]

class Program
{
    public static void Main(string[] args)
    {
        Debug.Assert(args == null);

        Debug.Assert(args == null, "args should be null.");

        int i = 0;
        i++; // Increment i

        DebugEx.Assert(() => args == null);

        DebugEx.Assert(() => args.Select(a => a.Length).Sum() == 10);

        DebugEx.Assert(() => args.Length == 5);

        DebugEx.Assert(() => 5 + 3 + 2 >= 100);

        DebugEx.Assert(() => Increment(args.Length) == Increment(Increment(args.ToList().Count())));

        var local = 5;
        DebugEx.Assert(() => local < 0);

        DebugEx.Assert(() => (new object()).GetHashCode() == 1 + 1 + 1);
    }

    private static int Increment(int i)
    {
        return i + 1;
    }
}
